/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin/proc.h>
#include <bin/types.h>
#include <fcntl.h>
#include <stddef.h>

struct bin_proc_fd *bin_proc_fd_find(const struct bin_proc *const p, const int fd)
{
    if (fd < 0)
        return NULL;

    for (size_t i = 0; i < p->n_fds; i++)
    {
        struct bin_proc_fd *const pfd = &p->fds[i];

        if (pfd->fd == fd && pfd->flags & O_WRONLY)
            return pfd;
    }

    return NULL;
}
